package ovh.herisson.Clyde.Services;

import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.TokenRepository;
import ovh.herisson.Clyde.Tables.Role;
import ovh.herisson.Clyde.Tables.Token;
import ovh.herisson.Clyde.Tables.User;
import ovh.herisson.Clyde.TokenCleaner;

import java.nio.charset.StandardCharsets;
import java.security.SecureRandom;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

@Service
public class TokenService {

    TokenRepository tokenRepo;

    public TokenService(TokenRepository tokenRepo){
        this.tokenRepo = tokenRepo;
    }


    public String generateNewToken(){
        byte[] bytes = new byte[64];
        new SecureRandom().nextBytes(bytes);
        String token = new String(bytes, StandardCharsets.US_ASCII);
        System.out.println(token);
        return token;
    }

    public User getUserFromToken(String token){
        return tokenRepo.getByToken(token).getUser();
    }

    public void saveToken(Token token, Date expirationDate){
        tokenRepo.save(token);
        TokenCleaner cleaner = new TokenCleaner(token, tokenRepo);
    }

}